VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Line"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain

Dim startlinex As Integer
Dim startliney As Integer
Dim endlinex As Integer
Dim endliney As Integer

Dim isWallTile(1023, 1023) As Boolean
Public usewalltile As Boolean

Dim undoch As Changes

Dim oldtilex As Integer
Dim oldtiley As Integer


Public linew As Integer

Private Sub Class_Initialize()
    linew = 1
End Sub

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, X As Single, Y As Single, Optional Shift As Integer)
Dim curtilex As Integer
Dim curtiley As Integer
   On Error GoTo MouseDown_Error

curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vScr.value + Y)) / (TileH * parent.magnifier.Zoom)))

    If curtilex < 0 Then curtilex = 0
    If curtiley < 0 Then curtiley = 0
    If curtilex > 1023 Then curtilex = 1023
    If curtiley > 1023 Then curtiley = 1023


    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
        tmpTileSizeX = parent.multTileLeftx
        tmpTileSizeY = parent.multTileLefty
        usewalltile = parent.useWallTileLeft
        parent.walltiles.curwall = parent.curWallTileLeft
    Else
        tmptile = parent.tilesetright
        tmpTileSizeX = parent.multTileRightx
        tmpTileSizeY = parent.multTileRighty
        usewalltile = parent.useWallTileRight
        parent.walltiles.curwall = parent.curWallTileRight
    End If

    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If

    'If SharedVar.curtool <> T_filledellipse And SharedVar.curtool <> T_filledrectangle Then
        parent.undoredo.ResetRedo
        Set undoch = New Changes
'    End If
    
    startlinex = curtilex
    startliney = curtiley
    
    If usewalltile Then
        Call ClearIsWallTile
        If SharedVar.curtool = T_line Then
            Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , , , True)
        ElseIf SharedVar.curtool = T_rectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , , True)
        ElseIf SharedVar.curtool = T_filledrectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , , True)
        ElseIf SharedVar.curtool = T_ellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, , , , True)
        ElseIf SharedVar.curtool = T_filledellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , , True)
        End If
    End If
    
    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, False)
    ElseIf SharedVar.curtool = T_rectangle Or SharedVar.curtool = T_filledrectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, False)
    ElseIf SharedVar.curtool = T_ellipse Or SharedVar.curtool = T_filledellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, False)
    End If
    parent.mapchanged = True

oldtilex = curtilex
oldtiley = curtiley

   On Error GoTo 0
   Exit Sub

MouseDown_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseDown of Class Module Line"
End Sub

Sub MouseMove(Button As Integer, X As Single, Y As Single, origX As Single, origY As Single, step As Integer, Optional usingctrl As Boolean)
Dim curtilex As Integer
Dim curtiley As Integer
Dim fromtilex As Integer
Dim fromtiley As Integer
Dim tempx1 As Integer
Dim tempy1 As Integer


   On Error GoTo MouseMove_Error

    curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
    curtiley = (Int(((parent.vScr.value + Y)) / (TileH * parent.magnifier.Zoom)))

    If oldtilex = curtilex And oldtiley = curtiley Then
        Exit Sub
    Else
        oldtilex = curtilex
        oldtiley = curtiley
    End If
    
    tempx1 = startlinex
    tempy1 = startliney
    
If usingctrl Then
    fromtilex = (Int(((parent.hScr.value + origX)) / (TileW * parent.magnifier.Zoom)))
    fromtiley = (Int(((parent.vScr.value + origY)) / (TileH * parent.magnifier.Zoom)))
    
    startlinex = fromtilex - (curtilex - fromtilex)
    startliney = fromtiley - (curtiley - fromtiley)
Else
    startlinex = tempx1
    startliney = tempy1
End If

If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023 Or _
    startlinex < 0 Or startliney < 0 Or startlinex > 1023 Or startliney > 1023) Then

    If parent.tline.linew <> 1 Then
        If curtilex - Int(parent.tline.linew / 2) < 0 Then curtilex = Int(parent.tline.linew / 2) - 1
        If curtiley - Int(parent.tline.linew / 2) < 0 Then curtiley = Int(parent.tline.linew / 2) - 1
        If curtilex + Int(parent.tline.linew / 2) > 1023 Then curtilex = 1023 - Int(parent.tline.linew / 2)
        If curtiley + Int(parent.tline.linew / 2) > 1023 Then curtiley = 1023 - Int(parent.tline.linew / 2)
        If startlinex - Int(parent.tline.linew / 2) < 0 Then startlinex = Int(parent.tline.linew / 2) - 1
        If startliney - Int(parent.tline.linew / 2) < 0 Then startliney = Int(parent.tline.linew / 2) - 1
        If startlinex + Int(parent.tline.linew / 2) > 1023 Then startlinex = 1023 - Int(parent.tline.linew / 2)
        If startliney + Int(parent.tline.linew / 2) > 1023 Then startliney = 1023 - Int(parent.tline.linew / 2)
    Else
        If curtilex < 0 Then curtilex = 0
        If curtiley < 0 Then curtiley = 0
        If curtilex > 1023 Then curtilex = 1023
        If curtiley > 1023 Then curtiley = 1023
        If startlinex < 0 Then startlinex = 0
        If startliney < 0 Then startliney = 0
        If startlinex > 1023 Then startlinex = 1023
        If startliney > 1023 Then startliney = 1023
    End If
'    Exit Sub
End If
If Not SharedVar.MouseDown Then
    Exit Sub
End If

    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
        tmpTileSizeX = parent.multTileLeftx
        tmpTileSizeY = parent.multTileLefty
        usewalltile = parent.useWallTileLeft
        parent.walltiles.curwall = parent.curWallTileLeft
    Else
        tmptile = parent.tilesetright
        tmpTileSizeX = parent.multTileRightx
        tmpTileSizeY = parent.multTileRighty
        usewalltile = parent.useWallTileRight
        parent.walltiles.curwall = parent.curWallTileRight
    End If
    
    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If

    If endlinex = curtilex And endliney = curtiley Then
        Exit Sub
    End If

    Call parent.UpdatePreview(False)
    
    If usewalltile Then
        Call ClearIsWallTile
        If SharedVar.curtool = T_line Then
            Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , , step, True)
        ElseIf SharedVar.curtool = T_rectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , step, True)
        ElseIf SharedVar.curtool = T_filledrectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step, True)
        ElseIf SharedVar.curtool = T_ellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, , , step, True)
        ElseIf SharedVar.curtool = T_filledellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step, True)
        End If
    End If
    
    
    
    
    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , , step)
    ElseIf SharedVar.curtool = T_rectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , step)
    ElseIf SharedVar.curtool = T_filledrectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step)
    ElseIf SharedVar.curtool = T_ellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, , , step)
    ElseIf SharedVar.curtool = T_filledellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step)
    End If

    startlinex = tempx1
    startliney = tempy1

   On Error GoTo 0
   Exit Sub

MouseMove_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseMove of Class Module Line"

End Sub

Sub MouseUp(Button As Integer, X As Single, Y As Single, origX As Single, origY As Single, step As Integer, Optional usingctrl As Boolean)
Dim curtilex As Integer
Dim curtiley As Integer
Dim fromtilex As Integer
Dim fromtiley As Integer
Dim tempx1 As Integer
Dim tempy1 As Integer
    
    
   On Error GoTo MouseUp_Error

    curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
    curtiley = (Int(((parent.vScr.value + Y)) / (TileH * parent.magnifier.Zoom)))

    tempx1 = startlinex
    tempy1 = startliney
    
    If usingctrl Then
            fromtilex = (Int(((parent.hScr.value + origX)) / (TileW * parent.magnifier.Zoom)))
            fromtiley = (Int(((parent.vScr.value + origY)) / (TileH * parent.magnifier.Zoom)))
    
            startlinex = fromtilex - (curtilex - fromtilex)
            startliney = fromtiley - (curtiley - fromtiley)
    Else
            startlinex = tempx1
            startliney = tempy1
    End If

If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023 Or _
    startlinex < 0 Or startliney < 0 Or startlinex > 1023 Or startliney > 1023) Then

    If parent.tline.linew <> 1 Then
        If curtilex - Int(parent.tline.linew / 2) < 0 Then curtilex = Int(parent.tline.linew / 2) - 1
        If curtiley - Int(parent.tline.linew / 2) < 0 Then curtiley = Int(parent.tline.linew / 2) - 1
        If curtilex + Int(parent.tline.linew / 2) > 1023 Then curtilex = 1023 - Int(parent.tline.linew / 2)
        If curtiley + Int(parent.tline.linew / 2) > 1023 Then curtiley = 1023 - Int(parent.tline.linew / 2)
        If startlinex - Int(parent.tline.linew / 2) < 0 Then startlinex = Int(parent.tline.linew / 2) - 1
        If startliney - Int(parent.tline.linew / 2) < 0 Then startliney = Int(parent.tline.linew / 2) - 1
        If startlinex + Int(parent.tline.linew / 2) > 1023 Then startlinex = 1023 - Int(parent.tline.linew / 2)
        If startliney + Int(parent.tline.linew / 2) > 1023 Then startliney = 1023 - Int(parent.tline.linew / 2)
    Else
        If curtilex < 0 Then curtilex = 0
        If curtiley < 0 Then curtiley = 0
        If curtilex > 1023 Then curtilex = 1023
        If curtiley > 1023 Then curtiley = 1023
        If startlinex < 0 Then startlinex = 0
        If startliney < 0 Then startliney = 0
        If startlinex > 1023 Then startlinex = 1023
        If startliney > 1023 Then startliney = 1023
    End If
'    Exit Sub
End If

    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
        tmpTileSizeX = parent.multTileLeftx
        tmpTileSizeY = parent.multTileLefty
        usewalltile = parent.useWallTileLeft
        parent.walltiles.curwall = parent.curWallTileLeft
    Else
        tmptile = parent.tilesetright
        tmpTileSizeX = parent.multTileRightx
        tmpTileSizeY = parent.multTileRighty
        usewalltile = parent.useWallTileRight
        parent.walltiles.curwall = parent.curWallTileRight
    End If
    
    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If
    
    If usewalltile Then
        Call ClearIsWallTile
        If SharedVar.curtool = T_line Then
            Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , , step, True)
        ElseIf SharedVar.curtool = T_rectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, False, , step, True)
        ElseIf SharedVar.curtool = T_filledrectangle Then
            Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step, True)
        ElseIf SharedVar.curtool = T_ellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, , , step, True)
        ElseIf SharedVar.curtool = T_filledellipse Then
            Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, , step, True)
        End If
    End If
    
    If SharedVar.curtool = T_line Then
        Call DrawLine(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, , , , step)
    ElseIf SharedVar.curtool = T_rectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, False, , step)
    ElseIf SharedVar.curtool = T_filledrectangle Then
        Call DrawTileRectangle(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, True, True, step)
    ElseIf SharedVar.curtool = T_ellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, , , step)
    ElseIf SharedVar.curtool = T_filledellipse Then
        Call DrawEllipse(tmptile, startlinex, startliney, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, True, True, step)
    End If
    
    If parent.magnifier.UsingPixels Then
        parent.UpdateLevel
    Else
        If tmptile = 0 Or tmptile = 256 Then
            parent.UpdateLevel
        Else
            parent.UpdatePreview
        End If
    End If
    
    Call parent.undoredo.AddToUndo(undoch)
    
    startlinex = tempx1
    startliney = tempy1

    Call ClearIsWallTile

   On Error GoTo 0
   Exit Sub

MouseUp_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseUp of Class Module Line"
    
End Sub

Sub DrawLine(tilenr As Integer, startx As Integer, starty As Integer, endx As Integer, endy As Integer, undoch As Changes, multTileX As Integer, multtiley As Integer, Optional onpreview As Boolean = True, Optional refresh As Boolean = True, Optional appendundo As Boolean = True, Optional ignoreThickness As Boolean = False, Optional step As Integer = 0, Optional tagWallTiles As Boolean = False)
    Dim Width As Integer
   On Error GoTo DrawLine_Error

    Width = linew
    Dim i As Integer
    Dim j As Integer
    
    If tagWallTiles = True Then
        'We're using walltiles, define which tiles will be in the area to tile
        If parent.tline.linew <> 1 And Not ignoreThickness And Not multTileX > 1 And Not multtiley > 1 Then
            For j = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                For i = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                    Call DrawBaseLine(1, startx + i, starty + j, endx + i, endy + j, step, undoch, multTileX, multtiley, onpreview, False, appendundo, tagWallTiles = True)
                Next
            Next
        Else
            Call DrawBaseLine(1, startx, starty, endx, endy, step, undoch, multTileX, multtiley, onpreview, refresh, appendundo, True)
        End If
            
    Else
    
        If parent.tline.linew <> 1 And Not ignoreThickness And Not multTileX > 1 And Not multtiley > 1 Then
            For j = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                For i = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                    Call DrawBaseLine(tilenr, startx + i, starty + j, endx + i, endy + j, step, undoch, multTileX, multtiley, onpreview, False, appendundo)
                Next
            Next
            If refresh Then
                If Not onpreview Then
                    If tilenr = 256 Or tilenr = 0 Then
                        parent.UpdateLevel
                    Else
                        parent.UpdatePreview
                    End If
                Else
                    parent.picpreview.refresh
                End If
            End If
        Else
            Call DrawBaseLine(tilenr, startx, starty, endx, endy, step, undoch, multTileX, multtiley, onpreview, refresh, appendundo)
        End If

    End If

   On Error GoTo 0
   Exit Sub

DrawLine_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawLine of Class Module Line"
    
End Sub
Sub DrawBaseLine(tilenr As Integer, _
                 startx As Integer, starty As Integer, _
                 endx As Integer, endy As Integer, _
                 step As Integer, _
                 undoch As Changes, _
                 multTileX As Integer, _
                 multtiley As Integer, _
                 Optional onpreview As Boolean = True, Optional refresh As Boolean = True, _
                 Optional appendundo As Boolean = True, _
                 Optional tagWallTiles As Boolean = False)
                 
                 

   On Error GoTo DrawBaseLine_Error
    Dim tnr As Integer
    If tilenr = 0 Then tnr = 256 Else tnr = tilenr




    ' Bresenham's line algorithm for Microsoft Visual Basic 6.0
    ' Implementation by Robert Lee  July, 2002 Public Domain
    

    Dim InitialX As Integer
    Dim InitialY As Integer
    Dim FinalX As Integer
    Dim FinalY As Integer
    
    Dim i As Integer
    Dim j As Integer
    
    Dim val As Integer
    Dim tmp As Integer
    
    InitialX = startx
    InitialY = starty
    FinalX = endx
    FinalY = endy
    
    Dim Steep As Boolean
    Dim DeltaX As Integer, DeltaY As Integer, Delta As Integer
    Dim StepX As Integer, StepY As Integer
    Dim coord As Integer
    
    Dim correctStepX As Integer
    Dim correctStepY As Integer
    If multTileX > 1 Then
        correctStepX = multTileX
    Else
        correctStepX = step + 1
    End If
    
    If multtiley > 1 Then
        correctStepY = multtiley
    Else
        correctStepY = step + 1
    End If
    
    Steep = False
    DeltaX = Abs(FinalX - InitialX) / correctStepX
    If (FinalX - InitialX) > 0 Then
        StepX = correctStepX
    Else
        StepX = -correctStepX
    End If
    DeltaY = Abs(FinalY - InitialY) / correctStepY
    If (FinalY - InitialY) > 0 Then
        StepY = correctStepY
    Else
        StepY = -correctStepY
    End If
    
    If DeltaY > DeltaX Then
        Steep = True
        Swap InitialX, InitialY
        Swap DeltaX, DeltaY
        Swap StepX, StepY
    End If
    
    
    Dim lbx As Integer
    Dim lby As Integer

    lbx = Int(parent.hScr.value / (TileW * parent.magnifier.Zoom))
    lby = Int(parent.vScr.value / (TileH * parent.magnifier.Zoom))

    Delta = (DeltaY * 2) - DeltaX
    
    For coord = 0 To DeltaX - 1
        If Steep Then
            Call DrawTiles(tilenr, InitialY, InitialX, lbx, lby, undoch, multTileX, multtiley, onpreview, refresh, appendundo, tagWallTiles)
        Else
            Call DrawTiles(tilenr, InitialX, InitialY, lbx, lby, undoch, multTileX, multtiley, onpreview, refresh, appendundo, tagWallTiles)
        End If
        
        While Delta >= 0
            InitialY = InitialY + StepY
            Delta = Delta - (DeltaX * 2)
        Wend
        InitialX = InitialX + StepX
        Delta = Delta + (DeltaY * 2)
    Next coord
    
    Call DrawTiles(tilenr, FinalX, FinalY, lbx, lby, undoch, multTileX, multtiley, onpreview, refresh, appendundo, tagWallTiles)

    If refresh And Not tagWallTiles Then
        If Not onpreview Then
            If tnr = 256 Then
                parent.UpdateLevel
            Else
                parent.UpdatePreview
            End If
        Else
            parent.picpreview.refresh
        End If
    End If

   On Error GoTo 0
   Exit Sub

DrawBaseLine_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawBaseLine of Class Module Line"
    
 End Sub

Sub DrawTiles(tilenr As Integer, InitialX As Integer, InitialY As Integer, lbx As Integer, lby As Integer, _
                undoch As Changes, _
                multTileX As Integer, _
                multtiley As Integer, _
                Optional onpreview As Boolean = True, Optional refresh As Boolean = True, _
                Optional appendundo As Boolean = True, _
                Optional tagWallTiles As Boolean = False)
    Dim i As Integer
    Dim j As Integer
    Dim val As Integer
    Dim tmp As Integer
    Dim tnr As Integer
    
    For j = 0 To multtiley - 1
        For i = 0 To multTileX - 1
            If InitialY + i >= 0 And InitialX + j >= 0 And _
               InitialY + i < 1024 And InitialX + j < 1024 Then
            
                If tagWallTiles Then
                    isWallTile(InitialX + i, InitialY + j) = True
                Else
                    If parent.pastetype <> p_under Or _
                       parent.pastetype = p_under And parent.getTile(InitialX + i, InitialY + j) = 0 Then
                        If usewalltile Then
                            val = 0
                            If isWallTile(InitialX + i + 1, InitialY + j) Or parent.walltiles.IsValidTileforWall(parent.getTile(InitialX + i + 1, InitialY + j)) Then val = val + 1
                            If isWallTile(InitialX + i, InitialY + j - 1) Or parent.walltiles.IsValidTileforWall(parent.getTile(InitialX + i, InitialY + j - 1)) Then val = val + 2
                            If isWallTile(InitialX + i - 1, InitialY + j) Or parent.walltiles.IsValidTileforWall(parent.getTile(InitialX + i - 1, InitialY + j)) Then val = val + 4
                            If isWallTile(InitialX + i, InitialY + j + 1) Or parent.walltiles.IsValidTileforWall(parent.getTile(InitialX + i, InitialY + j + 1)) Then val = val + 8
                            tmp = parent.walltiles.getWallTile(parent.walltiles.curwall, val)
                            If tmp <> 0 Then
                                tilenr = tmp
                            End If
                        End If

                        If Not onpreview Then
                            If isTileSpecial(parent, InitialX + i, InitialY + j) Then
                                Call SearchAndDestroyObject(parent, InitialX + i, InitialY + j, undoch, appendundo)
                            End If
                            If InitialX + i >= 0 And InitialX + i <= 1023 And _
                               InitialY + j >= 0 And InitialY + j <= 1023 Then
                                Call parent.setTile(InitialX + i, InitialY + j, tilenr + i + 19 * j, undoch, appendundo)
                                Call parent.UpdateLevelTile(InitialX + i, InitialY + j, False)
                            End If
                        Else
                            If Not parent.magnifier.UsingPixels Then
                                If tnr + i + 19 * j = 256 Then
                                    BitBlt parent.picpreview.hdc, (InitialX + i - lbx) * (TileW * parent.magnifier.Zoom), (InitialY + j - lby) * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.picempty.hdc, 0, 0, vbSrcCopy
                                Else
                                    BitBlt parent.picpreview.hdc, (InitialX + i - lbx) * (TileW * parent.magnifier.Zoom), (InitialY + j - lby) * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.piczoomtileset.hdc, ((tilenr + i + 19 * j - 1) Mod 19) * (TileW * parent.magnifier.Zoom), Int((tilenr + i + 19 * j - 1) / 19) * (TileH * parent.magnifier.Zoom), vbSrcCopy
                                End If
                            Else
                                Call SetPixel(parent.picpreview.hdc, (InitialX + i - lbx), (InitialY + j - lby), TilePixelColor(tilenr + i + 19 * j))
                            End If
                        End If
                    End If
                End If
            End If
        Next
    Next
End Sub

Private Sub Swap(X As Integer, Y As Integer)
    Dim tmp As Integer
    tmp = X
    X = Y
    Y = tmp

 End Sub

Sub DrawTileRectangle(tilenr As Integer, startx As Integer, starty As Integer, endx As Integer, endy As Integer, undoch As Changes, multTileX As Integer, multtiley As Integer, Optional onpreview As Boolean = True, Optional filled As Boolean = False, Optional appendundo As Boolean = True, Optional step As Integer = 0, Optional tagWallTiles As Boolean = False)

    Dim i As Integer
    Dim j As Integer
    
   On Error GoTo DrawTileRectangle_Error
    
    Call DrawLine(tilenr, startx, starty, endx, starty, undoch, multTileX, multtiley, onpreview, False, appendundo, , step, tagWallTiles = True)
    Call DrawLine(tilenr, endx, starty, endx, endy, undoch, multTileX, multtiley, onpreview, False, appendundo, , step, tagWallTiles = True)
    Call DrawLine(tilenr, endx, endy, startx, endy, undoch, multTileX, multtiley, onpreview, False, appendundo, , step, tagWallTiles = True)
    Call DrawLine(tilenr, startx, endy, startx, starty, undoch, multTileX, multtiley, onpreview, False, appendundo, , step, tagWallTiles = True)
    
    If filled = True Then
        If startx > endx Then
            Swap startx, endx
        End If
        
        If starty > endy Then
            Swap starty, endy
        End If
        
        If Not onpreview Or tagWallTiles Then
            For j = starty + multtiley To endy - multtiley Step multtiley
                Call DrawLine(tilenr, startx + multTileX, j, endx - multTileX, j, undoch, multTileX, multtiley, onpreview, False, appendundo, True, 0, tagWallTiles)
            Next
        End If
    End If
    
    If Not tagWallTiles Then
        If Not onpreview Then
            parent.UpdatePreview
        Else
            parent.picpreview.refresh
        End If
    End If
    
   On Error GoTo 0
   Exit Sub

DrawTileRectangle_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawTileRectangle of Class Module Line"
    
 End Sub

 Sub DrawEllipse(tilenr As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal xx As Integer, ByVal yy As Integer, undoch As Changes, multTileX As Integer, multtiley As Integer, Optional onpreview As Boolean = True, Optional filled As Boolean, Optional appendundo As Boolean = True, Optional step As Integer = 0, Optional tagWallTiles As Boolean = False)
    Dim cx#, cy#, px#, py#, xp#, yp#
    Dim theta#, dtheta#, a#, b#
    Dim i As Integer
    Dim j As Integer
    
    
   On Error GoTo DrawEllipse_Error

    cx = X + (xx - X) / 2#
    cy = Y + (yy - Y) / 2#
    a = (xx - X) / 2#
    b = (yy - Y) / 2#
    
    dtheta = 0.05
    
    For theta = 0# To 2 * 3.14 + dtheta Step dtheta
        xp = cx + a * Cos(theta)
        yp = cy + b * Sin(theta)
        If theta <> 0 Then
            Call DrawLine(tilenr, CInt(xp), CInt(yp), CInt(px), CInt(py), undoch, multTileX, multtiley, onpreview, False, appendundo, , step, tagWallTiles)
        End If

        px = xp: py = yp
    Next theta

If a = 0 Or b = 0 Then GoTo skip

If X > xx Then
Swap X, xx
End If
If Y > yy Then
Swap Y, yy
End If

    If filled = True Then
        If Not onpreview Or tagWallTiles Then
            For j = Y To yy Step multtiley
                For i = X To xx Step multTileX
                    If ((((i - cx) ^ 2) / a ^ 2) + (((j - cy) ^ 2) / b ^ 2)) < 1 Then
                        Call DrawLine(tilenr, i, j, i, j, undoch, multTileX, multtiley, onpreview, False, , , step, tagWallTiles)
                    End If

                Next
            Next
        End If
    End If
skip:
        
        
    
    If Not tagWallTiles Then
        If Not onpreview Then
            parent.UpdatePreview
        Else
            parent.picpreview.refresh
        End If
    End If

   On Error GoTo 0
   Exit Sub

DrawEllipse_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawEllipse of Class Module Line"

End Sub


Sub ClearIsWallTile()
    Erase isWallTile
End Sub
