VERSION 5.00
Begin VB.Form frmColor 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Color map"
   ClientHeight    =   2790
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3060
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   186
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   204
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtRGB 
      Alignment       =   1  'Right Justify
      Height          =   285
      Index           =   2
      Left            =   840
      MaxLength       =   3
      TabIndex        =   11
      Text            =   "B"
      Top             =   2400
      Width           =   495
   End
   Begin VB.TextBox txtRGB 
      Alignment       =   1  'Right Justify
      Height          =   285
      Index           =   1
      Left            =   840
      MaxLength       =   3
      TabIndex        =   10
      Text            =   "G"
      Top             =   2160
      Width           =   495
   End
   Begin VB.Frame Frame1 
      Caption         =   "Choose a color"
      Height          =   2775
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3015
      Begin VB.CommandButton cmd_cancel 
         Cancel          =   -1  'True
         Caption         =   "Cancel"
         Height          =   255
         Left            =   2160
         TabIndex        =   12
         Top             =   1680
         Width           =   735
      End
      Begin VB.TextBox txtRGB 
         Alignment       =   1  'Right Justify
         Height          =   285
         Index           =   0
         Left            =   840
         MaxLength       =   3
         TabIndex        =   9
         Text            =   "R"
         Top             =   1920
         Width           =   495
      End
      Begin VB.CommandButton cmd_current 
         Caption         =   "Current"
         Height          =   255
         Left            =   2160
         TabIndex        =   6
         Top             =   2400
         Width           =   735
      End
      Begin VB.CommandButton cmd_default 
         Caption         =   "Default"
         Height          =   255
         Left            =   2160
         TabIndex        =   5
         Top             =   2040
         Width           =   735
      End
      Begin VB.CommandButton cmd_OK 
         Caption         =   "OK"
         Height          =   255
         Left            =   2160
         TabIndex        =   2
         Top             =   1320
         Width           =   735
      End
      Begin VB.PictureBox colormap 
         AutoRedraw      =   -1  'True
         Height          =   1695
         Left            =   120
         MousePointer    =   2  'Cross
         Picture         =   "frmColor.frx":0000
         ScaleHeight     =   109
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   117
         TabIndex        =   1
         Top             =   240
         Width           =   1815
         Begin VB.Shape colorpicker 
            DrawMode        =   6  'Mask Pen Not
            Height          =   105
            Left            =   720
            Shape           =   3  'Circle
            Top             =   600
            Width           =   105
         End
         Begin VB.Line colorline2 
            DrawMode        =   6  'Mask Pen Not
            X1              =   32
            X2              =   32
            Y1              =   64
            Y2              =   56
         End
         Begin VB.Line colorline1 
            DrawMode        =   6  'Mask Pen Not
            X1              =   32
            X2              =   44
            Y1              =   64
            Y2              =   64
         End
      End
      Begin VB.Label lblBa 
         Caption         =   "Blue:"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   2400
         Width           =   615
      End
      Begin VB.Label lblGa 
         Caption         =   "Green:"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   2160
         Width           =   615
      End
      Begin VB.Line preview2 
         BorderColor     =   &H000000FF&
         X1              =   2520
         X2              =   2520
         Y1              =   1080
         Y2              =   600
      End
      Begin VB.Line preview1 
         BorderColor     =   &H000000FF&
         X1              =   2160
         X2              =   2880
         Y1              =   840
         Y2              =   840
      End
      Begin VB.Shape Shape1 
         BackColor       =   &H00000000&
         BackStyle       =   1  'Opaque
         Height          =   495
         Left            =   2160
         Top             =   600
         Width           =   735
      End
      Begin VB.Label lblRa 
         Caption         =   "Red:"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   1920
         Width           =   615
      End
      Begin VB.Label lbl_preview 
         Alignment       =   2  'Center
         Caption         =   "Preview"
         Height          =   255
         Left            =   2160
         TabIndex        =   3
         Top             =   360
         Width           =   735
      End
   End
End
Attribute VB_Name = "frmColor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Stores index of object that called the form
Public index As Integer

'Stores color we are working with
Dim color As Long

'Stores color that is currently set
Dim currentcolor As Long

Private Sub Cmd_cancel_Click()
    frmOptions.Enabled = True
    Unload Me
End Sub

Private Sub cmd_current_Click()

color = currentcolor

    Dim coord() As Single
    ReDim coord(1) As Single
    coord = FindColor(color)
    Call PlacePointer(coord(0), coord(1))

    Call UpdateValues
    
End Sub

Private Sub cmd_default_Click()

    Select Case index
        Case 0, 4
            color = RGB(0, 0, 200)
        Case 1, 5
            color = RGB(200, 0, 0)
        Case 2, 6
            color = RGB(150, 150, 150)
        Case 3, 7
            color = RGB(80, 80, 80)
    End Select
    
    Dim coord() As Single
    ReDim coord(1) As Single
    coord = FindColor(color)
    Call PlacePointer(coord(0), coord(1))
    
    Call UpdateValues

End Sub

Private Sub cmd_OK_Click()
    frmOptions.Enabled = True
    Call frmOptions.SetColor(index, color)
    Unload Me
End Sub

Private Sub colormap_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    If x <= 0 Then x = 0
    If x >= colormap.ScaleWidth - 1 Then x = colormap.ScaleWidth - 1
    If y <= 0 Then y = 0
    If y >= colormap.ScaleHeight - 1 Then y = colormap.ScaleHeight - 1

    color = GetPixel(colormap.hdc, x, y)
    Call UpdateValues
    Call PlacePointer(x, y)

End Sub

Private Sub colormap_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button Then Call colormap_MouseDown(Button, Shift, x, y)
End Sub

Private Sub Form_Load()
    frmOptions.Enabled = False
    color = frmOptions.GetColor(index)
    currentcolor = color

    Set Me.Icon = frmGeneral.Icon

    Dim coord() As Single
    ReDim coord(1) As Single
    coord = FindColor(color)
    Call PlacePointer(coord(0), coord(1))

    Call UpdateValues
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    frmOptions.Enabled = True
    Unload Me
End Sub

Private Sub txtRGB_Change(index As Integer)
    If Not IsNumeric(txtRGB(index).text) Or InStr(txtRGB(index).text, "e") > 0 Or InStr(txtRGB(index).text, ".") > 0 Or InStr(txtRGB(index).text, ",") > 0 Or InStr(txtRGB(index).text, "-") > 0 Or InStr(txtRGB(index).text, " ") > 0 Then
        Dim oldselstart As Integer
        oldselstart = txtRGB(index).SelStart - 1 'char  typed so always one more
        If oldselstart < 0 Then oldselstart = 0
        
        'remove all characters aside from nrs
        Dim i As Integer
        Dim finalresult As String
        For i = 1 To Len(txtRGB(index).text)
            If Asc(Mid$(txtRGB(index).text, i, 1)) < Asc("0") Or _
               Asc(Mid$(txtRGB(index).text, i, 1)) > Asc("9") Then
                Dim result As String
                If i - 1 >= 1 Then result = Mid$(txtRGB(index).text, 1, i - 1)
                If i + 1 <= Len(txtRGB(index).text) Then result = result + Mid$(txtRGB(index).text, i + 1, Len(txtRGB(index).text) - (i))
                finalresult = result
            End If
        Next
        txtRGB(index).text = finalresult
        If oldselstart > Len(txtRGB(index).text) Then
            txtRGB(index).SelStart = Len(txtRGB(index).text)
        Else
            txtRGB(index).SelStart = oldselstart
        End If
    End If
    
    If val(txtRGB(index).text) < 0 Then
        txtRGB(index).text = 0
    End If
    
    If val(txtRGB(index).text) >= 255 Then
        txtRGB(index).text = 255
    End If
End Sub

Private Sub txtRGB_GotFocus(index As Integer)
    txtRGB(index).SelStart = 0
    txtRGB(index).SelLength = Len(txtRGB(index).text)
End Sub

Private Sub txtRGB_LostFocus(index As Integer)
    color = RGB(val(txtRGB(0).text), val(txtRGB(1).text), val(txtRGB(2).text))
    
    Dim coord() As Single
    ReDim coord(1) As Single
    coord = FindColor(color)
    Call PlacePointer(coord(0), coord(1))
    
    Call UpdateValues(index)
End Sub

Private Sub UpdateValues(Optional ignoreindex As Integer = -1)
    
    If ignoreindex <> 0 Then txtRGB(0).text = GetRED(color)
    If ignoreindex <> 1 Then txtRGB(1).text = GetGREEN(color)
    If ignoreindex <> 2 Then txtRGB(2).text = GetBLUE(color)

    preview1.BorderColor = color
    preview2.BorderColor = color
End Sub

Private Sub PlacePointer(x As Single, y As Single)
    colorpicker.Left = x - 3
    colorpicker.Top = y - 3
    
    colorline1.x1 = x
    colorline1.x2 = x
    colorline1.y1 = y - 5
    colorline1.y2 = y + 5
    
    colorline2.x1 = x - 5
    colorline2.x2 = x + 5
    colorline2.y1 = y
    colorline2.y2 = y
End Sub

Private Function FindColor(color As Long) As Single()
    Dim retval() As Single
    ReDim retval(1) As Single
    Dim i As Integer
    Dim j As Integer
    
    Dim curpixel As Long
    Dim curdelta As Integer
    
    Dim mindelta As Integer
    Dim minx As Single
    Dim miny As Single
    
    mindelta = 255 * 3
    
    For j = 0 To colormap.ScaleWidth
        For i = 0 To colormap.ScaleHeight
            curpixel = GetPixel(colormap.hdc, i, j)
            curdelta = Abs(GetRED(curpixel) - GetRED(color)) + Abs(GetGREEN(curpixel) - GetGREEN(color)) + Abs(GetBLUE(curpixel) - GetBLUE(color))
            If curdelta < mindelta Then
                mindelta = curdelta
                minx = i
                miny = j
            End If
            If mindelta = 0 Then
                retval(0) = minx
                retval(1) = miny
                FindColor = retval
                Exit Function
            End If
        Next
    Next
    retval(0) = minx
    retval(1) = miny
    FindColor = retval
End Function

