VERSION 5.00
Begin VB.Form frmReplace 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Switch/Replace Tiles"
   ClientHeight    =   3585
   ClientLeft      =   135
   ClientTop       =   420
   ClientWidth     =   6795
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   239
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   453
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox pictilesetlarge 
      Appearance      =   0  'Flat
      BackColor       =   &H80000004&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   510
      Left            =   120
      ScaleHeight     =   34
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   124
      TabIndex        =   6
      Top             =   240
      Width           =   1860
      Begin VB.Line Line1 
         X1              =   40
         X2              =   64
         Y1              =   16
         Y2              =   16
      End
      Begin VB.Line Line2 
         X1              =   56
         X2              =   64
         Y1              =   8
         Y2              =   16
      End
      Begin VB.Line Line3 
         X1              =   56
         X2              =   64
         Y1              =   24
         Y2              =   16
      End
      Begin VB.Line Line4 
         X1              =   48
         X2              =   40
         Y1              =   8
         Y2              =   16
      End
      Begin VB.Line Line5 
         X1              =   48
         X2              =   40
         Y1              =   24
         Y2              =   16
      End
      Begin VB.Shape shpright 
         BorderColor     =   &H0000FFFF&
         Height          =   510
         Left            =   1080
         Top             =   0
         Width           =   510
      End
      Begin VB.Shape shpleft 
         BorderColor     =   &H000000FF&
         Height          =   510
         Left            =   0
         Top             =   0
         Width           =   510
      End
   End
   Begin VB.PictureBox pictileset 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3360
      Left            =   2160
      ScaleHeight     =   224
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   304
      TabIndex        =   5
      Top             =   120
      Width           =   4560
      Begin VB.Shape rightsel 
         BorderColor     =   &H0000FFFF&
         Height          =   240
         Left            =   240
         Top             =   0
         Width           =   240
      End
      Begin VB.Shape leftsel 
         BorderColor     =   &H000000FF&
         Height          =   240
         Left            =   0
         Top             =   0
         Width           =   240
      End
   End
   Begin VB.OptionButton optreplaceleftright 
      Caption         =   "Replace left -> right"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1560
      Width           =   1935
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Done"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   3120
      Width           =   1695
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "Switch or replace tiles"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   2520
      Width           =   1695
   End
   Begin VB.CheckBox chkinselection 
      Caption         =   "In selection only"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   2160
      Width           =   1815
   End
   Begin VB.OptionButton optswitchleftright 
      Caption         =   "Switch left  <-> right"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   1200
      Value           =   -1  'True
      Width           =   1935
   End
   Begin VB.Label lblyellow 
      Height          =   255
      Left            =   1200
      TabIndex        =   8
      Top             =   840
      Width           =   615
   End
   Begin VB.Label lblred 
      Alignment       =   2  'Center
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   840
      Width           =   495
   End
End
Attribute VB_Name = "frmReplace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


'defines which option to use
Enum replaceenum
    switchleftright
    replaceleftright
End Enum

'holds the left and right tile
Public tilesetleft As Integer
Public tilesetright As Integer


Private Sub cmdCancel_Click()
'Cancels the form
    Unload Me
End Sub

Private Sub cmdOK_Click()
'Proceed with replace or switching, and pass the attributes
'to the general form

    Dim using As replaceenum
    'holds the source and destination tile for replace
    '(when switching it doesn't matter which is src and
    'which is dest)
    Dim tilesrc As Integer
    Dim tiledest As Integer
    
    'no tiles bigger than 1 tile
   On Error GoTo cmdOK_Click_Error

    If tilesetleft = 217 Or tilesetleft = 219 Or tilesetleft = 220 Or _
    tilesetright = 217 Or tilesetright = 219 Or tilesetright = 220 Then
        MsgBox "You can not use special tiles for tile switching/replacing", vbInformation
        Exit Sub
    End If
    
    'check for uselessness
    If tilesetleft = tilesetright Then
        MsgBox "You can't switch or replace a tile by the same tile... that's useless.", vbInformation
        Exit Sub
    End If
    
    'determine the operation
    If optswitchleftright.value Then
        using = switchleftright
    ElseIf optreplaceleftright.value Then
        using = replaceleftright
    End If
    
    'check to avoid filling the entire map with tiles
    If chkinselection.value = vbUnchecked Then
        If (using = replaceleftright And tilesetleft = 0) Or _
            (using = switchleftright And (tilesetleft = 0 Or tilesetright = 0)) Then
        MsgBox "You can't replace empty tiles all over the map.", vbInformation
        Exit Sub
        End If
    End If
            
            
    
    
    tilesrc = tilesetleft
    tiledest = tilesetright
    
    'pass the info to the executereplace method and execute it
    Call frmGeneral.ExecuteReplace(using, tilesrc, tiledest, chkinselection.value = vbChecked)

   On Error GoTo 0
   Exit Sub

cmdOK_Click_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure cmdOK_Click of Form frmReplace"
    
End Sub

Private Sub Form_Activate()
'Updates the preview when activated
    DoEvents
    UpdatePreview
End Sub

Private Sub Form_Load()
'Copies the tileset from the general form
    Set Me.Icon = frmGeneral.Icon
    
    BitBlt pictileset.hdc, 0, 0, pictileset.Width, pictileset.Height, frmGeneral.pictileset.hdc, 0, 0, vbSrcCopy
    pictileset.refresh
        
    'set the left and right tile
    Call SetLeftSelection(tilesetleft)
    Call SetRightSelection(tilesetright)

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'Cancel the form
    cmdCancel_Click
End Sub



Private Sub optreplaceleftright_Click()
'Hide one part of the arrow
    Line4.Visible = False
    Line5.Visible = False
    
    UpdatePreview
End Sub

Private Sub optswitchleftright_Click()
'Show both sides of the arrow
    Line4.Visible = True
    Line5.Visible = True
    
    UpdatePreview
End Sub

Private Sub pictileset_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Selects the tile
    If Not (X > 0 And Y > 0 And X < pictileset.Width And Y < pictileset.Height) Then
        'out of range, don't select it
        Exit Sub
    End If
    
    'set the selected tile
    If Button = vbLeftButton Then
        SetLeftSelection (Int(Y / 16) * 19 + Int((X / 16) + 1))
    Else
        SetRightSelection (Int(Y / 16) * 19 + Int((X / 16) + 1))
    End If
    
End Sub

Private Sub pictileset_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Do the same as mousedown
    If Button Then
        Call pictileset_MouseDown(Button, Shift, X, Y)
    End If
    
    Dim tilenr As Integer
    tilenr = Int(Y / 16) * 19 + Int((X / 16) + 1)
pictileset.ToolTipText = TilesetToolTipText(tilenr)

End Sub

Sub SetLeftSelection(tilenr)
'Set left selection of the tileset on the given tilenr
    If tilenr = 0 Then Exit Sub
    If tilenr > 256 Then Exit Sub
    
    'move the left shape
    leftsel.Visible = True
    leftsel.Left = ((tilenr - 1) Mod 19) * 16
    leftsel.Top = (Int((tilenr - 1) / 19)) * 16

    tilesetleft = tilenr Mod 256
    
    'if both shapes overlap make them white
    If tilesetleft = tilesetright Then
        rightsel.BorderColor = vbWhite
    Else
        rightsel.BorderColor = vbYellow
    End If
    
    'update the preview
    UpdatePreview
    
End Sub

Sub SetRightSelection(tilenr)
'Set right selection of the tileset on the given tilenr
    If tilenr = 0 Then Exit Sub
    If tilenr > 256 Then Exit Sub
    
    'move the right shape
    rightsel.Visible = True
    rightsel.Left = ((tilenr - 1) Mod 19) * 16
    rightsel.Top = (Int((tilenr - 1) / 19)) * 16
    
    tilesetright = tilenr Mod 256
    
    'if both of them overlap make them white
    If tilesetleft = tilesetright Then
        rightsel.BorderColor = vbWhite
    Else
        rightsel.BorderColor = vbYellow
    End If
    
    UpdatePreview
End Sub

Private Sub UpdatePreview()
'Updates the preview
    'stretch the 2 selected tiles from the tileset into the 2 large preview
    StretchBlt pictilesetlarge.hdc, shpleft.Left + 1, shpleft.Top + 1, shpleft.Width - 2, shpleft.Height - 2, pictileset.hdc, leftsel.Left, leftsel.Top, TileW, TileH, vbSrcCopy
    StretchBlt pictilesetlarge.hdc, shpright.Left + 1, shpright.Top + 1, shpright.Width - 2, shpright.Height - 2, pictileset.hdc, rightsel.Left, rightsel.Top, TileW, TileH, vbSrcCopy
    
    'update the numbers
    lblred.Caption = tilesetleft
    lblyellow.Caption = tilesetright
End Sub


