VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Hand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim dragxcorrection As Integer
Dim dragycorrection As Integer
Dim oldDragX As Integer
Dim oldDragY As Integer

Dim parent As frmMain

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(x As Single, y As Single)
    dragxcorrection = Int(x / (TileW * parent.magnifier.Zoom))
    dragycorrection = Int(y / (TileH * parent.magnifier.Zoom))
End Sub

Sub MouseMove(x As Single, y As Single)
Dim curtilex As Integer
Dim curtiley As Integer
   On Error GoTo MouseMove_Error

curtilex = (Int(((parent.hScr.value + x)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vScr.value + y)) / (TileH * parent.magnifier.Zoom)))
If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
    Exit Sub
End If
    
    If SharedVar.MouseDown Then
    
            Dim valH As Integer
            Dim valV As Integer
        
        If parent.hScr.value + (dragxcorrection - Int(x / (TileW * parent.magnifier.Zoom))) * (TileW * parent.magnifier.Zoom) < 0 Then
            valH = 0
        ElseIf parent.hScr.value + (dragxcorrection - Int(x / (TileW * parent.magnifier.Zoom))) * (TileW * parent.magnifier.Zoom) > parent.hScr.Max Then
            valH = parent.hScr.Max
        Else
            valH = parent.hScr.value + (dragxcorrection - Int(x / (TileW * parent.magnifier.Zoom))) * (TileW * parent.magnifier.Zoom)
        End If
            
        If parent.vScr.value + (dragycorrection - Int(y / (TileH * parent.magnifier.Zoom))) * (TileH * parent.magnifier.Zoom) < 0 Then
            valV = 0
        ElseIf parent.vScr.value + (dragycorrection - Int(y / (TileH * parent.magnifier.Zoom))) * (TileH * parent.magnifier.Zoom) > parent.vScr.Max Then
            valV = parent.vScr.Max
        Else
            valV = parent.vScr.value + (dragycorrection - Int(y / (TileH * parent.magnifier.Zoom))) * (TileH * parent.magnifier.Zoom)
        End If
        
        Call parent.setScrollBarValues(valH, valV, False)
        
        If oldDragX <> dragxcorrection Or oldDragY <> dragycorrection Then
            parent.UpdateLevel
        End If
        
        oldDragX = dragxcorrection
        oldDragY = dragycorrection
        dragxcorrection = Int(x / (TileW * parent.magnifier.Zoom))
        dragycorrection = Int(y / (TileH * parent.magnifier.Zoom))
    End If

   On Error GoTo 0
   Exit Sub

MouseMove_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseMove of Class Module Hand"
End Sub

Sub MouseUp()
    'do nothing
End Sub


